Bug Hunting Session
Bug 119775 - Incorrect keyboard navigation when insert table toolbar button is dropped down and right or down arrow key is pressed
Summary: Incorrect keyboard navigation when insert table toolbar button is dropped dow...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
6.0.0.0.alpha0+
Hardware: All All
: medium normal
Assignee: Jim Raykowski
URL:
Whiteboard: target:6.3.0
Keywords: accessibility, bibisected, bisected, regression
Depends on:
Blocks: Button-Controls
  Show dependency treegraph
 
Reported: 2018-09-10 01:25 UTC by Jim Raykowski
Modified: 2019-05-21 07:06 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jim Raykowski 2018-09-10 01:25:45 UTC
When Insert table toolbar button is dropped downed right or down arrow key press moves focus to Set Paragraph Styles combo box.

Steps for reproduction:

1) Open Writer
2) Click on Insert table toolbar drop down button in Standard toolbar
3) Press right or down arrow key

Results: Insert table toolbar button remains dropped down and keyboard focus is on Set Paragraph Styles combo box in Formatting toolbar.

Expected results: Focus remains on More Options... button

This also occurs for the Insert Special Characters drop down button
Comment 1 Buovjaga 2018-10-01 19:12:39 UTC
Repro.

Bibisected on Win 6.0 repo to: https://cgit.freedesktop.org/libreoffice/core/commit/?id=cb9970400d0bbd73e508f25a67e1ad2c7dd28eb6

Wayland: Make various popups work in the overflow toolbar

Adding Cc: to Maxim Monastirsky

An interesting fact is that still in 3.6 the arrow keys determined the cell/row amounts. Later, there appeared a defect, where the selection did not appear with a single arrow, but you had to also press another arrow key. Then in the 5.x era it changed to just staying at More options button.
Comment 2 Jim Raykowski 2019-05-04 23:34:28 UTC
(In reply to Buovjaga from comment #1)
> An interesting fact is that still in 3.6 the arrow keys determined the
> cell/row amounts. Later, there appeared a defect, where the selection did
> not appear with a single arrow, but you had to also press another arrow key.
> Then in the 5.x era it changed to just staying at More options button.

Reading the code it seems up until when the 'More Options...' button was added the keyboard should have been able to be used.

Here is a patch to restore this ability when *activated by keyboard*.

https://gerrit.libreoffice.org/#/c/71813/

The patch does not show the 'More Options..." button when the Insert Table popup window is activated using the keyboard. The Insert Table dialog automatically opens when row or column amount using arrow keys exceeds the row or column size of the popup. The Tab key also opens the Insert Table dialog. Up Arrow key and Left Arrow key when on first row/column as well as Escape key and Enter key at any time close the popup.

When the Mouse is used to activate the Insert Table popup window the 'More Options...' button is displayed. To prevent the key input buggy behavior reported, key input is limited to Space, Return, and Escape when the focus is on the 'More Options...' button.
Comment 3 Commit Notification 2019-05-20 22:08:04 UTC
Jim Raykowski committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/b26b6cab5d8147d35f76a21c333719c80840d08d%5E%21

tdf#119775 Make keyboard use work for TableWindow popup window

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.